config/urls.py
from django.conf import settings
from django.urls import include, path
from django.conf.urls.static import static
from django.contrib import admin
from django.views import defaults as default_views
from uvik_colorboard.colorboard.views import ColorBoardView

urlpatterns = [
    path("", ColorBoardView.as_view(), name="home"),
    # Django Admin, use {% url 'admin:index' %}
    path(settings.ADMIN_URL, admin.site.urls),
] + static(
    settings.MEDIA_URL, document_root=settings.MEDIA_ROOT
)

if settings.DEBUG:
    # This allows the error pages to be debugged during development, just visit
    # these url in browser to see how these error pages look like.
    urlpatterns += [
        path(
            "400/",
            default_views.bad_request,
            kwargs={"exception": Exception("Bad Request!")},
        ),
        path(
            "403/",
            default_views.permission_denied,
            kwargs={"exception": Exception("Permission Denied")},
        ),
        path(
            "404/",
            default_views.page_not_found,
            kwargs={"exception": Exception("Page not Found")},
        ),
        path("500/", default_views.server_error),
    ]
    if "debug_toolbar" in settings.INSTALLED_APPS:
        import debug_toolbar

        urlpatterns = [path("__debug__/", include(debug_toolbar.urls))] + urlpatterns

uvik_colorboard/users/urls.py
from django.urls import path

from uvik_colorboard.users.views import (
    user_list_view,
    user_redirect_view,
    user_update_view,
    user_detail_view,
)

app_name = "users"
urlpatterns = [
    path("", view=user_list_view, name="list"),
    path("~redirect/", view=user_redirect_view, name="redirect"),
    path("~update/", view=user_update_view, name="update"),
    path("<str:username>/", view=user_detail_view, name="detail"),
]

uvik_colorboard/colorboard/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator


class GameResults(models.Model):
    number_of_players = models.IntegerField(validators=[
            MaxValueValidator(4),
            MinValueValidator(1)
        ])
    squares_on_board = models.IntegerField(validators=[
            MaxValueValidator(79),
            MinValueValidator(1)
        ])
    number_cards_in_the_deck = models.IntegerField(validators=[
            MaxValueValidator(200),
            MinValueValidator(1)
        ])
    characters_on_the_board = models.CharField(max_length=400)
    cards_in_the_deck = models.CharField(max_length=400)
    result = models.CharField(max_length=50)

    def __str__(self):
        return self.result

uvik_colorboard/users/models.py
from django.contrib.auth.models import AbstractUser
from django.db.models import CharField
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _


class User(AbstractUser):

    # First Name and Last Name do not cover name patterns
    # around the globe.
    name = CharField(_("Name of User"), blank=True, max_length=255)

    def get_absolute_url(self):
        return reverse("users:detail", kwargs={"username": self.username})

uvik_colorboard/colorboard/forms.py
from django.forms import Form, IntegerField, CharField, NumberInput, Textarea
from django.core.validators import MaxValueValidator, MinValueValidator, RegexValidator


class ColorboardForm(Form):
    number_of_players = IntegerField(
        label='The​ ​number​ ​of​ ​players',
        initial=2,
        validators=[MinValueValidator(1),
                    MaxValueValidator(4)],
        widget=NumberInput(attrs={'class': 'form-control'}))

    squares_on_board = IntegerField(
        label='The​ ​number​ ​of​ ​squares​ ​on​ ​the​ ​board​',
        initial=13,
        validators=[MinValueValidator(1),
                    MaxValueValidator(79)],
        widget=NumberInput(attrs={'class': 'form-control'}))

    number_cards_in_the_deck = IntegerField(
        label='The​ ​number​ ​of​ ​cards​ ​in​ ​the​ ​deck',
        initial=8,
        validators=[MinValueValidator(1),
                    MaxValueValidator(200)],
        widget=NumberInput(attrs={'class': 'form-control'}))

    characters_on_the_board = CharField(
        label='The​ ​characters​ ​representing​ ​the​ ​colored​ ​squares​ ​on​ ​the​ ​board',
        initial='RYGPBRYGBRPOP',
        validators=[RegexValidator(regex="^[A-Z]+$", message="Allowed only uppercase A-Z ")],
        widget=Textarea(attrs={'class': 'form-control', 'rows': 4}))

    cards_in_the_deck = CharField(
        label='The​ ​cards​ ​in​ ​the​ ​deck​',
        initial='R, B, GG, Y, P, B, P, RR',
        validators=[RegexValidator(regex=r"^[A-Z,\s]+$",
                                   message="Allowed only uppercase A-Z comma and space"), ],
        widget=Textarea(attrs={'class': 'form-control', 'rows': 4}))

uvik_colorboard/users/forms.py
from django.contrib.auth import get_user_model, forms
from django.core.exceptions import ValidationError
from django.utils.translation import ugettext_lazy as _

User = get_user_model()


class UserChangeForm(forms.UserChangeForm):

    class Meta(forms.UserChangeForm.Meta):
        model = User


class UserCreationForm(forms.UserCreationForm):

    error_message = forms.UserCreationForm.error_messages.update(
        {"duplicate_username": _("This username has already been taken.")}
    )

    class Meta(forms.UserCreationForm.Meta):
        model = User

    def clean_username(self):
        username = self.cleaned_data["username"]

        try:
            User.objects.get(username=username)
        except User.DoesNotExist:
            return username

        raise ValidationError(self.error_messages["duplicate_username"])

uvik_colorboard/colorboard/views.py
from django.shortcuts import render
from django.views import View
from .forms import ColorboardForm
from .game_class import Game
from .models import GameResults


class ColorBoardView(View):
    def get(self, request):
        """Renders page with form and prints result to the user"""

        form = ColorboardForm()
        result = None
        return render(request, 'colorboard/home.html', {'form': form, 'result': result})

    def post(self, request):
        """Validates data from form and runs game with given data"""

        form = ColorboardForm(request.POST)
        result = None
        if form.is_valid():
            data = form.cleaned_data
            game = Game(**data)
            result = game.start_game()

            GameResults(result=result, **data).save()

        return render(request, 'colorboard/home.html', {'form': form, 'result': result})

uvik_colorboard/users/views.py
from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse
from django.views.generic import DetailView, ListView, RedirectView, UpdateView

User = get_user_model()


class UserDetailView(LoginRequiredMixin, DetailView):

    model = User
    slug_field = "username"
    slug_url_kwarg = "username"


user_detail_view = UserDetailView.as_view()


class UserListView(LoginRequiredMixin, ListView):

    model = User
    slug_field = "username"
    slug_url_kwarg = "username"


user_list_view = UserListView.as_view()


class UserUpdateView(LoginRequiredMixin, UpdateView):

    model = User
    fields = ["name"]

    def get_success_url(self):
        return reverse("users:detail", kwargs={"username": self.request.user.username})

    def get_object(self):
        return User.objects.get(username=self.request.user.username)


user_update_view = UserUpdateView.as_view()


class UserRedirectView(LoginRequiredMixin, RedirectView):

    permanent = False

    def get_redirect_url(self):
        return reverse("users:detail", kwargs={"username": self.request.user.username})


user_redirect_view = UserRedirectView.as_view()

uvik_colorboard/templates/403_csrf.html
{% extends "base.html" %}

{% block title %}Forbidden (403){% endblock %}

{% block content %}
<h1>Forbidden (403)</h1>

<p>CSRF verification failed. Request aborted.</p>
{% endblock content %}

uvik_colorboard/templates/base.html
{% load static i18n %}<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <title>{% block title %}uvik-colorboard{% endblock title %}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">

    <!-- HTML5 shim, for IE6-8 support of HTML5 elements -->
    <!--[if lt IE 9]>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv.min.js"></script>
    <![endif]-->

    <link rel="icon" href="{% static 'images/favicons/favicon.ico' %}">

    {% block css %}
    
    <!-- Latest compiled and minified Bootstrap 4.1.1 CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/css/bootstrap.min.css" integrity="sha384-WskhaSGFgHYWDcbwN70/dfYBj47jz9qbsMId/iRN3ewGhXQFZCSftd1LZCfmhktB" crossorigin="anonymous">
    

    <!-- Your stuff: Third-party CSS libraries go here -->
    
    <!-- This file stores project-specific CSS -->
    
    <link href="{% static 'css/project.css' %}" rel="stylesheet">
    
    
    {% endblock %}

  </head>

  <body>

    <div class="mb-1">
      <nav class="navbar navbar-expand-md navbar-light bg-light">
        <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <a class="navbar-brand" href="{% url 'home' %}">uvik-colorboard</a>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul class="navbar-nav mr-auto">
            <li class="nav-item active">
              <a class="nav-link" href="{% url 'home' %}">Home <span class="sr-only">(current)</span></a>
            </li>
          </ul>
        </div>
      </nav>

    </div>

    <div class="container">

      {% if messages %}
          {% for message in messages %}
              <div class="alert {% if message.tags %}alert-{{ message.tags }}{% endif %}">{{ message }}</div>
          {% endfor %}
      {% endif %}

      {% block content %}

        Content

      {% endblock content %}

    </div> <!-- /container -->

    {% block modal %}{% endblock modal %}

    <!-- Le javascript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    {% block javascript %}
      
      <!-- Required by Bootstrap v4.1.1 -->
      <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
      <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js" integrity="sha384-smHYKdLADwkXOn1EmN1qk/HfnUcbVRZyYmZ4qpPea6sjB/pTJ0euyQp0Mk8ck+5T" crossorigin="anonymous"></script>

      <!-- Your stuff: Third-party javascript libraries go here -->
      

      <!-- place project specific Javascript in this file -->
      
      <script src="{% static 'js/project.js' %}"></script>
      

    {% endblock javascript %}
  </body>
</html>
 

uvik_colorboard/templates/colorboard/home.html
{% extends "base.html" %}

{% block title %}Colorboard{% endblock %}

{% block content %}
<div class="container">
    <div class="row justify-content-center">
        <div class="col-6">
            <h1 class="text-center p-3">Colorboard Game</h1>
            {% if result %}
                <div class="alert alert-success" role="alert">
                        {{ result }}
                    </div>
            {% endif %}

            <form class="pt-3" action="" method="post">
                <input type="hidden" name="csrfmiddlewaretoken" value="{{ csrf_token }}">
                {% for field in form %}
                    <div class="form-group row">

                        <label class="col-sm-4 col-form-label">{{ field.label }}</label>
                        <div class="col-sm-8">
                            {{ field }}
                            {% if field.errors %}
                                <div class="text-danger bg-warning p-1 pt-3 pr-3 mb-2 mt-2">
                                    {{ field.errors }}
                                </div>
                            {% endif %}
                        </div>

                    </div>
                {% endfor %}
                <input type="submit" value="Submit" class="btn btn-primary" style="margin:1%">
            </form>
        </div>
    </div>
</div>
{% endblock content %}

uvik_colorboard/templates/pages/home.html
{% extends "base.html" %}

uvik_colorboard/templates/users/user_detail.html
{% extends "base.html" %}
{% load static %}

{% block title %}User: {{ object.username }}{% endblock %}

{% block content %}
<div class="container">

  <div class="row">
    <div class="col-sm-12">

      <h2>{{ object.username }}</h2>
      {% if object.name %}
        <p>{{ object.name }}</p>
      {% endif %}
    </div>
  </div>

{% if object == request.user %}
<!-- Action buttons -->
<div class="row">

  <div class="col-sm-12">
    <a class="btn btn-primary" href="{% url 'users:update' %}" role="button">My Info</a>
    <a class="btn btn-primary" href="{% url 'account_email' %}" role="button">E-Mail</a>
    <!-- Your Stuff: Custom user template urls -->
  </div>

</div>
<!-- End Action buttons -->
{% endif %}


</div>
{% endblock content %}

uvik_colorboard/templates/users/user_form.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}{{ user.username }}{% endblock %}

{% block content %}
  <h1>{{ user.username }}</h1>
  <form class="form-horizontal" method="post" action="{% url 'users:update' %}">
    {% csrf_token %}
    {{ form|crispy }}
    <div class="control-group">
      <div class="controls">
        <button type="submit" class="btn">Update</button>
      </div>
    </div>
  </form>
{% endblock %}

uvik_colorboard/templates/users/user_list.html
{% extends "base.html" %}
{% load static i18n %}
{% block title %}Members{% endblock %}

{% block content %}
<div class="container">
  <h2>Users</h2>

  <div class="list-group">
    {% for user in user_list %}
      <a href="{% url 'users:detail' user.username %}" class="list-group-item">
        <h4 class="list-group-item-heading">{{ user.username }}</h4>
      </a>
    {% endfor %}
  </div>
</div>
{% endblock content %}